#!/usr/bin/env python

if __name__ == "__main__":
    import sys, os
    sys.setrecursionlimit(10000)

    from simplify import simplified

    if "-s" in sys.argv:
        simplified.set_single_instance_mode()
    elif "-m" in sys.argv:
        simplified.set_multiple_instance_mode()
    elif "-ms" in sys.argv:
        simplified.set_selective_multiple_instance_mode()
    elif "-mp" in sys.argv:
        simplified.set_prolific_multiple_instance_mode()

    import simplify.viewer
    import simplify.fixinstances
    from simplify.annotate import AnnotationError, Importer, load

    importer = Importer(sys.path)
    try:
        builtins = load(os.path.join("lib", "builtins.py"))
        module = load(sys.argv[1], builtins, None, importer, "-na" in sys.argv)
    except simplified.SimplifiedError, exc:
        raise
    else:
        if "-i" in sys.argv:
            simplify.fixinstances.fix_structures(module)
            simplify.fixinstances.fix_structures(builtins)
            simplify.fixinstances.fix(module)
            simplify.fixinstances.fix(builtins)
        if "-d" in sys.argv:
            simplify.viewer.makedocs(module, importer.modules.values(), builtins, distinct=("-i" in sys.argv))

# vim: tabstop=4 expandtab shiftwidth=4
